blob: ef1d18641012858058e3f3305e1efd6d54092b7e [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Ollie Lho184a4042005-11-26 21:55:36 +000017PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000018
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000019###############################################################################
20# Defaults for the toolchain.
21
22# If you want to cross-compile, just run e.g.
23# make CC=i586-pc-msdosdjgpp-gcc
24# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000025#
26# Note for anyone editing this Makefile: gnumake will happily ignore any
27# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000028STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000029INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000030DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000031PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000032MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010033CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000034EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000035RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000036PKG_CONFIG ?= pkg-config
37BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000038
Stefan Taunerfd0d4132012-09-25 21:24:55 +000039# The following parameter changes the default programmer that will be used if there is no -p/--programmer
40# argument given when running flashrom. The predefined setting does not enable any default so that every
41# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
42# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
43# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
44# system attached to an external programmer while the default programmer is set to the internal programmer, and
45# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
46# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020047# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
48CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000049# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000051# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020052# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000053# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000054
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000055# If your compiler spits out excessive warnings, run make WARNERROR=no
56# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000057WARNERROR ?= yes
58
59ifeq ($(WARNERROR), yes)
60CFLAGS += -Werror
61endif
62
Stefan Taunere37735a2015-01-26 22:03:35 +000063ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000064PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000065override CPPFLAGS += -I$(LIBS_BASE)/include
66override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000067endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000068
Stefan Taunerbfb067b2016-01-07 18:13:07 +000069ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000070override PKG_CONFIG += --static
71override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072endif
73
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000074# Set LC_ALL=C to minimize influences of the locale.
75# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060076# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077LC_ALL=C
78export LC_ALL
79
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000080dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000081
82# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
83# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090084debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
85 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000086
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000087###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020088# Dependency handling.
89
90DEPENDS_ON_SERIAL := \
91 CONFIG_BUSPIRATE_SPI \
92 CONFIG_PONY_SPI \
93 CONFIG_SERPROG \
94
95DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020096 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +020097 CONFIG_INTERNAL \
98 CONFIG_NICINTEL_SPI \
99 CONFIG_OGP_SPI \
100 CONFIG_PONY_SPI \
101 CONFIG_RAYER_SPI \
102
103DEPENDS_ON_LIBPCI := \
104 CONFIG_ATAHPT \
105 CONFIG_ATAPROMISE \
106 CONFIG_ATAVIA \
107 CONFIG_DRKAISER \
108 CONFIG_GFXNVIDIA \
109 CONFIG_INTERNAL \
110 CONFIG_IT8212 \
111 CONFIG_NIC3COM \
112 CONFIG_NICINTEL \
113 CONFIG_NICINTEL_EEPROM \
114 CONFIG_NICINTEL_SPI \
115 CONFIG_NICNATSEMI \
116 CONFIG_NICREALTEK \
117 CONFIG_OGP_SPI \
118 CONFIG_SATAMV \
119 CONFIG_SATASII \
120
121DEPENDS_ON_LIBUSB1 := \
122 CONFIG_CH341A_SPI \
123 CONFIG_DEDIPROG \
124 CONFIG_DEVELOPERBOX_SPI \
125 CONFIG_DIGILENT_SPI \
126 CONFIG_PICKIT2_SPI \
127 CONFIG_RAIDEN_DEBUG_SPI \
128 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200129 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200130
131DEPENDS_ON_LIBFTDI := \
132 CONFIG_FT2232_SPI \
133 CONFIG_USBBLASTER_SPI \
134
135DEPENDS_ON_LIBJAYLINK := \
136 CONFIG_JLINK_SPI \
137
Nico Huberafca7ac2021-06-27 13:35:21 +0200138define mark_unsupported
139$(foreach p,$1, \
140 $(if $(filter $($(p)),yes), \
141 $(eval UNSUPPORTED_FEATURES += $(p)=yes), \
142 $(eval override $(p) := no)))
143endef
144
Nico Huber29c68342021-06-27 14:34:16 +0200145define filter_deps
146$(strip $(foreach p,$1, \
147 $(if $(filter $($(p)),yes), \
148 $(p))))
149endef
150
Nico Hubera54f5a42021-06-27 14:27:41 +0200151define disable_all
152$(foreach p,$1, \
153 $(eval override $(p) := no))
154endef
155
156ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
157$(call disable_all,$(DEPENDS_ON_LIBUSB1))
158endif
159
160ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
161$(call disable_all,$(DEPENDS_ON_LIBPCI))
162endif
163
Nico Huber7f898972021-06-27 13:30:50 +0200164###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000165# General OS-specific settings.
166# 1. Prepare for later by gathering information about host and target OS
167# 2. Set compiler flags and parameters according to OSes
168# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000169
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000170# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000171HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100172ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000173# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
174CC = gcc
175endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100176
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000177ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000178STRIP_ARGS = -s
179endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000180
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000181# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000182# IMPORTANT: The following line must be placed before TARGET_OS is ever used
183# (of course), but should come after any lines setting CC because the line
184# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900185override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
186 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000187
188ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000189override CPPFLAGS += -I/opt/local/include -I/usr/local/include
190override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000191endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000192
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000193ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000194override CPPFLAGS += -I/usr/local/include
195override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000196endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000197
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000198ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000199override CPPFLAGS += -I/usr/local/include
200override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000201endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000202
Stefan Taunerc65b8552013-09-12 15:48:39 +0000203ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000204# Needs special `pciutils/pci.h` for older NetBSD packages
205PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
206override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000207override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000208endif
209
210ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000211override CPPFLAGS += -I/usr/local/include
212override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000213endif
214
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000215ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000216EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000217# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000218override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000219LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200220# Missing serial support.
221$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
222# Libraries not available for DOS
223$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000224endif
Ollie Lho184a4042005-11-26 21:55:36 +0000225
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000226# FIXME: Should we check for Cygwin/MSVC as well?
227ifeq ($(TARGET_OS), MinGW)
228EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000229# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000230FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000231# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000232# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000233FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100234
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000235# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200236$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
237# And programmers that need raw access.
238$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000239
Nico Huberca621782021-06-27 13:53:49 +0200240else # No MinGW
241
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100242# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200243$(call mark_unsupported,CONFIG_NI845X_SPI)
244
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100245endif
246
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000247ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000248ifeq ($(MAKECMDGOALS),)
249.DEFAULT_GOAL := libflashrom.a
250$(info Setting default goal to libflashrom.a)
251endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000252FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200253$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000254# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200255$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000256# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200257$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100258# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200259$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000260endif
261
Nico Huberdc8e54a2021-06-27 14:17:34 +0200262# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
263ifeq ($(filter $(TARGET_OS),Linux Android), )
264$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
265$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000266endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000267
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000268ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200269# Android on x86 (currently) does not provide raw PCI port I/O operations.
270$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000271endif
272
Stefan Tauner037cd842013-08-25 00:10:56 +0000273###############################################################################
274# General architecture-specific settings.
275# Like above for the OS, below we verify user-supplied options depending on the target architecture.
276
Uwe Hermann44ffd582011-08-20 14:16:00 +0000277# Determine the destination processor architecture.
278# IMPORTANT: The following line must be placed before ARCH is ever used
279# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000280# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900281override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
282 | tail -1 | cut -f 2 -d'"'))
283override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
284 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000285
Nico Huberc8801732017-12-01 18:19:43 +0000286# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
287ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200288$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000289endif
290
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000291# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000292# Right now this means the drivers below only work on x86.
293ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200294$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
295$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
296$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000297endif
298
Nico Huber8945b812021-06-27 14:24:53 +0200299# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
300# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000301# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700302ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200303$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
304$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
305$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000306endif
307
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000308###############################################################################
309# Flash chip drivers and bus support infrastructure.
310
Stefan Tauner4404f732013-09-12 08:28:56 +0000311CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000312 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300313 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100314 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
315 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000316
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000317###############################################################################
318# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000319
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200320LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000321
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000322###############################################################################
323# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000324
Stefan Tauner9b32de92014-08-08 23:52:33 +0000325CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000326
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200327# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
328# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
329# be obtained using util/getrevision.sh, which is the common case during development.
330-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200331VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200332MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000333
Stefan Tauner76347082016-11-27 17:45:49 +0100334SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000335
Stefan Tauner76347082016-11-27 17:45:49 +0100336# No spaces in release names unless set explicitly
337RELEASENAME ?= $(shell echo "$(VERSION)" | sed -e 's/ /_/')
338
339# Inform user of the version string
340$(info Replacing all version templates with $(VERSION).)
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000341
Stefan Tauner037cd842013-08-25 00:10:56 +0000342###############################################################################
343# Default settings of CONFIG_* variables.
344
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000345# Always enable internal/onboard support for now.
346CONFIG_INTERNAL ?= yes
347
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000348# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000349CONFIG_SERPROG ?= yes
350
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000351# RayeR SPIPGM hardware support
352CONFIG_RAYER_SPI ?= yes
353
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000354# PonyProg2000 SPI hardware support
355CONFIG_PONY_SPI ?= yes
356
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000357# Always enable 3Com NICs for now.
358CONFIG_NIC3COM ?= yes
359
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000360# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
361CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000362
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000363# Always enable SiI SATA controllers for now.
364CONFIG_SATASII ?= yes
365
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000366# Highpoint (HPT) ATA/RAID controller support.
367# IMPORTANT: This code is not yet working!
368CONFIG_ATAHPT ?= no
369
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000370# VIA VT6421A LPC memory support
371CONFIG_ATAVIA ?= yes
372
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000373# Promise ATA controller support.
374CONFIG_ATAPROMISE ?= no
375
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000376# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000377CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000378
James Lairdc60de0e2013-03-27 13:00:23 +0000379# Always enable Altera USB-Blaster dongles for now.
380CONFIG_USBBLASTER_SPI ?= yes
381
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000382# MSTAR DDC support needs more tests/reviews/cleanups.
383CONFIG_MSTARDDC_SPI ?= no
384
Justin Chevrier66e554b2015-02-08 21:58:10 +0000385# Always enable PICkit2 SPI dongles for now.
386CONFIG_PICKIT2_SPI ?= yes
387
Miklós Márton324929c2019-08-01 19:14:10 +0200388# Always enable STLink V3
389CONFIG_STLINKV3_SPI ?= yes
390
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000391# Always enable dummy tracing for now.
392CONFIG_DUMMY ?= yes
393
394# Always enable Dr. Kaiser for now.
395CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000396
Joerg Fischer5665ef32010-05-21 21:54:07 +0000397# Always enable Realtek NICs for now.
398CONFIG_NICREALTEK ?= yes
399
Andrew Morganc29c2e72010-06-07 22:37:54 +0000400# Disable National Semiconductor NICs until support is complete and tested.
401CONFIG_NICNATSEMI ?= no
402
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000403# Always enable Intel NICs for now.
404CONFIG_NICINTEL ?= yes
405
Idwer Vollering004f4b72010-09-03 18:21:21 +0000406# Always enable SPI on Intel NICs for now.
407CONFIG_NICINTEL_SPI ?= yes
408
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000409# Always enable EEPROM on Intel NICs for now.
410CONFIG_NICINTEL_EEPROM ?= yes
411
Mark Marshall90021f22010-12-03 14:48:11 +0000412# Always enable SPI on OGP cards for now.
413CONFIG_OGP_SPI ?= yes
414
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000415# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000416CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000417
Simon Glassae616512016-01-23 23:27:58 +0000418# Always enable Dediprog SF100 for now.
419CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000420
Daniel Thompson45e91a22018-06-04 13:46:29 +0100421# Always enable Developerbox emergency recovery for now.
422CONFIG_DEVELOPERBOX_SPI ?= yes
423
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000424# Always enable Marvell SATA controllers for now.
425CONFIG_SATAMV ?= yes
426
David Hendricksf9a30552015-05-23 20:30:30 -0700427# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
428CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000429CONFIG_LINUX_SPI ?= yes
430
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000431# Always enable ITE IT8212F PATA controllers for now.
432CONFIG_IT8212 ?= yes
433
Urja Rannikko0870b022016-01-31 22:10:29 +0000434# Winchiphead CH341A
435CONFIG_CH341A_SPI ?= yes
436
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100437# Digilent Development board JTAG
438CONFIG_DIGILENT_SPI ?= yes
439
Jean THOMASe28d8e42022-10-11 17:54:30 +0200440# DirtyJTAG
441CONFIG_DIRTYJTAG_SPI ?= yes
442
Marc Schink3578ec62016-03-17 16:23:03 +0100443# Disable J-Link for now.
444CONFIG_JLINK_SPI ?= no
445
Nico Huber83d52072021-06-27 00:07:13 +0200446# National Instruments USB-845x is Windows only and needs a proprietary library.
447CONFIG_NI845X_SPI ?= no
448
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000449# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000450CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000451
Stefan Taunerf3503372016-02-26 23:51:21 +0000452# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
453ifeq ($(CONFIG_NOTHING), yes)
454 ifeq ($(CONFIG_EVERYTHING), yes)
455 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
456 endif
457 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
458 $(if $(filter yes, $($(var))),\
459 $(eval $(var)=no)))
460endif
461
Patrick Georgiced7ab62015-01-19 19:52:34 +0000462# Enable all features if CONFIG_EVERYTHING=yes is given
463ifeq ($(CONFIG_EVERYTHING), yes)
464$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
465 $(if $(filter no, $($(var))),\
466 $(eval $(var)=yes)))
467endif
468
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000469# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200470
471ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200472override CONFIG_BITBANG_SPI = yes
473else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000474CONFIG_BITBANG_SPI ?= no
475endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000476
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000477###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000478# Handle CONFIG_* variables that depend on others set (and verified) above.
479
480# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
481ifeq ($(TARGET_OS), libpayload)
482ifeq ($(CONFIG_INTERNAL), yes)
483ifeq ($(CONFIG_INTERNAL_DMI), no)
484UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
485else
486override CONFIG_INTERNAL_DMI = yes
487endif
488endif
489endif
490
491# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
492CONFIG_INTERNAL_DMI ?= yes
493
494###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000495# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000496# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000497
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200498ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
499FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
500else
501FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
502endif
503
Stefan Tauner265fcac2014-06-02 00:12:23 +0000504FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000505
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000506ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000507FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000508PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000509ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000510PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200511PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000512ifeq ($(CONFIG_INTERNAL_DMI), yes)
513FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
514endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000515else
516endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000517endif
518
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000519ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000520FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000521PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000522NEED_SERIAL += CONFIG_SERPROG
523NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000524endif
525
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000526ifeq ($(CONFIG_RAYER_SPI), yes)
527FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
528PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000529NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000530endif
531
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000532ifeq ($(CONFIG_PONY_SPI), yes)
533FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
534PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000535NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000536endif
537
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000538ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000539FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000540PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000541endif
542
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000543ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000544FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000545PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000546endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000547
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000548ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000549FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000550PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000551endif
552
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000553ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000554FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000555PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000556endif
557
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000558ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000559FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000560PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000561endif
562
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000563ifeq ($(CONFIG_ATAVIA), yes)
564FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
565PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000566endif
567
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000568ifeq ($(CONFIG_ATAPROMISE), yes)
569FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
570PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000571endif
572
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000573ifeq ($(CONFIG_IT8212), yes)
574FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
575PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000576endif
577
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000578ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000579# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000580FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000581PROGRAMMER_OBJS += ft2232_spi.o
582endif
583
584ifeq ($(CONFIG_USBBLASTER_SPI), yes)
585# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000586FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000587PROGRAMMER_OBJS += usbblaster_spi.o
588endif
589
Justin Chevrier66e554b2015-02-08 21:58:10 +0000590ifeq ($(CONFIG_PICKIT2_SPI), yes)
591FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
592PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000593endif
594
Miklós Márton324929c2019-08-01 19:14:10 +0200595ifeq ($(CONFIG_STLINKV3_SPI), yes)
596FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
597PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200598endif
599
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000600ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000601FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000602PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000603endif
604
605ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000606FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000607PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000608endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000609
Joerg Fischer5665ef32010-05-21 21:54:07 +0000610ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000611FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000612PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000613endif
614
Andrew Morganc29c2e72010-06-07 22:37:54 +0000615ifeq ($(CONFIG_NICNATSEMI), yes)
616FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
617PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000618endif
619
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000620ifeq ($(CONFIG_NICINTEL), yes)
621FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
622PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000623endif
624
Idwer Vollering004f4b72010-09-03 18:21:21 +0000625ifeq ($(CONFIG_NICINTEL_SPI), yes)
626FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
627PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000628endif
629
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000630ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
631FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
632PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000633endif
634
Mark Marshall90021f22010-12-03 14:48:11 +0000635ifeq ($(CONFIG_OGP_SPI), yes)
636FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
637PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000638endif
639
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000640ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
641FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000642PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000643NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000644endif
645
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000646ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000647FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000648PROGRAMMER_OBJS += dediprog.o
649endif
650
Daniel Thompson45e91a22018-06-04 13:46:29 +0100651ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
652FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
653PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100654endif
655
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000656ifeq ($(CONFIG_SATAMV), yes)
657FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
658PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000659endif
660
David Hendricksf9a30552015-05-23 20:30:30 -0700661ifeq ($(CONFIG_LINUX_MTD), yes)
662# This is a totally ugly hack.
663FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
664PROGRAMMER_OBJS += linux_mtd.o
665endif
666
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000667ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000668# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000669FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000670PROGRAMMER_OBJS += linux_spi.o
671endif
672
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000673ifeq ($(CONFIG_MSTARDDC_SPI), yes)
674# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000675FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000676NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000677PROGRAMMER_OBJS += mstarddc_spi.o
678endif
679
Urja Rannikko0870b022016-01-31 22:10:29 +0000680ifeq ($(CONFIG_CH341A_SPI), yes)
681FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
682PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000683endif
684
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100685ifeq ($(CONFIG_DIGILENT_SPI), yes)
686FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
687PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100688endif
689
Jean THOMASe28d8e42022-10-11 17:54:30 +0200690ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
691FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
692PROGRAMMER_OBJS += dirtyjtag_spi.o
693endif
694
Marc Schink3578ec62016-03-17 16:23:03 +0100695ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100696FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
697PROGRAMMER_OBJS += jlink_spi.o
698endif
699
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100700ifeq ($(CONFIG_NI845X_SPI), yes)
701FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
702
703ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
704# if the user did not specified the NI-845x headers/lib path
705# do a guess for both 32 and 64 bit Windows versions
706NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100707NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200708
709# hack to access env variable containing brackets...
710PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
711
712ifneq ($(PROGRAMFILES_X86DIR),)
713ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
714NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
715NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
716endif
717endif
718
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100719else
720NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
721NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
722endif
723
724FEATURE_CFLAGS += $(NI845X_INCLUDES)
725LIBS += -lni845x
726PROGRAMMER_OBJS += ni845x_spi.o
727endif
728
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000729ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200730LIB_OBJS += serial.o
731ifeq ($(TARGET_OS), Linux)
732LIB_OBJS += custom_baud_linux.o
733else
734LIB_OBJS += custom_baud.o
735endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000736endif
737
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000738ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000739ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000740LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000741endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000742endif
743
Nico Huberf55ca202021-06-27 14:36:06 +0200744NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000745ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000746CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000747# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
748# libpci may need raw memory, MSR or PCI port I/O on some platforms.
749# Individual drivers might have the same needs as well.
750NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000751FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000752FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000753
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000754PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000755ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000756# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000757PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000758else
759PCILIBS += -lpci
760endif
761endif
762
763ifneq ($(NEED_RAW_ACCESS), )
764# Raw memory, MSR or PCI port I/O access.
765FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
766PROGRAMMER_OBJS += physmap.o hwaccess.o
767
768ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200769ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000770PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200771endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000772else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000773ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200774ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000775PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200776endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000777else
778ifeq ($(TARGET_OS), Darwin)
779# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000780PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000781endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000782endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000783endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000784
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000785endif
786
Nico Huberf55ca202021-06-27 14:36:06 +0200787NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000788ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000789CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100790PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000791# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
792ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
793USB1LIBS += -lusb
794else
795ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000796override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000797USB1LIBS += -lusb-1.0
798else
Stefan Tauner45207062016-02-19 08:17:24 +0000799USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
800override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000801endif
802endif
803endif
804
Nico Huberf55ca202021-06-27 14:36:06 +0200805NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200806ifneq ($(NEED_LIBFTDI), )
807FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
808FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
809FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
810FEATURE_CFLAGS += $(FTDI_INCLUDES)
811FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
812# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
813# into a hard requirement for libusb, defeating the purpose of auto-enabling.
814endif
815
Nico Huberf55ca202021-06-27 14:36:06 +0200816NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100817ifneq ($(NEED_LIBJAYLINK), )
818CHECK_LIBJAYLINK = yes
819JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
820override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
821endif
822
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000823ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000824FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000825CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000826endif
827
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000828FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000829
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000830# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000831FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000832
Nico Huber8624e8c2012-11-05 21:46:33 +0100833FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
834FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
835
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000836LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000837OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000838
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000839all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000840ifeq ($(ARCH), x86)
841 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
842endif
843
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000844$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100845 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000846
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000847libflashrom.a: $(LIBFLASHROM_OBJS)
848 $(AR) rcs $@ $^
849 $(RANLIB) $@
850
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000851# TAROPTIONS reduces information leakage from the packager's system.
852# If other tar programs support command line arguments for setting uid/gid of
853# stored files, they can be handled here as well.
854TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000855
Paul Fox05dfbe62009-06-16 21:08:06 +0000856%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100857 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000858
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000859# Make sure to add all names of generated binaries here.
860# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000861# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000862clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000863 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000864 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000865
Ollie Lho184a4042005-11-26 21:55:36 +0000866distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000867 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000868
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000869strip: $(PROGRAM)$(EXEC_SUFFIX)
870 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000871
Stefan Tauner56787082011-08-18 02:27:19 +0000872# to define test programs we use verbatim variables, which get exported
873# to environment variables and are referenced with $$<varname> later
874
875define COMPILER_TEST
876int main(int argc, char **argv)
877{
878 (void) argc;
879 (void) argv;
880 return 0;
881}
882endef
883export COMPILER_TEST
884
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000885compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000886 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000887 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000888 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000889 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
890 echo "found." || { echo "not found."; \
891 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000892 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000893 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000894 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000895 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900896 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000897 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000898 @printf "Target OS is "
899 @# FreeBSD wc will output extraneous whitespace.
900 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900901 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000902 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000903ifeq ($(TARGET_OS), libpayload)
904 @$(CC) --version 2>&1 | grep -q coreboot || \
905 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
906 echo "This might work but usually does not, please beware." )
907endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000908
Stefan Tauner56787082011-08-18 02:27:19 +0000909define LIBPCI_TEST
910/* Avoid a failing test due to libpci header symbol shadowing breakage */
911#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000912#if !defined PCIUTILS_PCI_H
Stefan Tauner56787082011-08-18 02:27:19 +0000913#include <pci/pci.h>
Stefan Taunerc65b8552013-09-12 15:48:39 +0000914#else
915#include <pciutils/pci.h>
916#endif
Stefan Tauner56787082011-08-18 02:27:19 +0000917struct pci_access *pacc;
918int main(int argc, char **argv)
919{
920 (void) argc;
921 (void) argv;
922 pacc = pci_alloc();
923 return 0;
924}
925endef
926export LIBPCI_TEST
927
Stefan Tauner56734502015-02-08 21:58:04 +0000928define PCI_GET_DEV_TEST
929/* Avoid a failing test due to libpci header symbol shadowing breakage */
930#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000931#if !defined PCIUTILS_PCI_H
Stefan Tauner56734502015-02-08 21:58:04 +0000932#include <pci/pci.h>
933#else
934#include <pciutils/pci.h>
935#endif
936struct pci_access *pacc;
937struct pci_dev *dev = {0};
938int main(int argc, char **argv)
939{
940 (void) argc;
941 (void) argv;
942 pacc = pci_alloc();
943 dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
944 return 0;
945}
946endef
947export PCI_GET_DEV_TEST
948
Stefan Taunere49edbb2016-01-31 22:10:14 +0000949define LIBUSB1_TEST
950#include <stddef.h>
951#include <libusb.h>
952int main(int argc, char **argv)
953{
954 (void)argc;
955 (void)argv;
956 libusb_init(NULL);
957 return 0;
958}
959endef
960export LIBUSB1_TEST
961
Marc Schink3578ec62016-03-17 16:23:03 +0100962define LIBJAYLINK_TEST
963#include <stddef.h>
964#include <libjaylink/libjaylink.h>
965int main(int argc, char **argv)
966{
967 struct jaylink_context *ctx;
968
969 (void)argc;
970 (void)argv;
971
972 jaylink_init(&ctx);
973 jaylink_exit(ctx);
974
975 return 0;
976}
977endef
978export LIBJAYLINK_TEST
979
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000980hwlibs: compiler
981 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000982ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000983 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000984 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000985 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000986 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
987 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000988 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000989 echo "Please install libpci headers or disable all features"; \
990 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000991 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000992 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
993 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000994 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000995 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000996 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000997 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000998 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
999 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001000 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001001 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
1002 echo "yes." || { echo "no."; \
1003 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001004 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
1005 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001006 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001007 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001008 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
1009 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001010 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001011 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001012 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001013endif
Stefan Taunere49edbb2016-01-31 22:10:14 +00001014ifeq ($(CHECK_LIBUSB1), yes)
1015 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
1016 @echo "$$LIBUSB1_TEST" > .test.c
1017 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1018 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1019 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001020 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001021 echo "Please install libusb-1.0 headers or disable all features"; \
1022 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001023 echo "See README for more information."; echo; \
1024 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1025 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
1026 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
1027 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
1028 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001029 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001030 echo "Please install libusb-1.0 or disable all features"; \
1031 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001032 echo "See README for more information."; echo; \
1033 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1034 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1035endif
Marc Schink3578ec62016-03-17 16:23:03 +01001036ifeq ($(CHECK_LIBJAYLINK), yes)
1037 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
1038 @echo "$$LIBJAYLINK_TEST" > .test.c
1039 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1040 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1041 echo "found." || { echo "not found."; echo; \
1042 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1043 echo "Please install libjaylink headers or disable the feature"; \
1044 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1045 echo "See README for more information."; echo; \
1046 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1047 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
1048 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
1049 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
1050 echo "yes." || { echo "no."; \
1051 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1052 echo "Please install libjaylink or disable the feature"; \
1053 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1054 echo "See README for more information."; echo; \
1055 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1056 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1057endif
Stefan Reinauer53e96252005-12-01 16:19:24 +00001058
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001059.features: features
1060
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001061# If a user does not explicitly request a non-working feature, we should
1062# silently disable it. However, if a non-working (does not compile) feature
1063# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001064# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001065featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001066ifeq ($(PROGRAMMER_OBJS),)
1067 @echo "You have to enable at least one programmer driver!"
1068 @false
1069endif
1070ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001071 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
1072 @false
1073endif
1074
Stefan Tauner56787082011-08-18 02:27:19 +00001075define FTDI_TEST
Stefan Tauner5c316f92015-02-08 21:57:52 +00001076#include <stdlib.h>
Stefan Tauner56787082011-08-18 02:27:19 +00001077#include <ftdi.h>
1078struct ftdi_context *ftdic = NULL;
1079int main(int argc, char **argv)
1080{
1081 (void) argc;
1082 (void) argv;
1083 return ftdi_init(ftdic);
1084}
1085endef
1086export FTDI_TEST
1087
Ilya A. Volynets-Evenbakh2c714ab2012-09-26 00:47:09 +00001088define FTDI_232H_TEST
1089#include <ftdi.h>
1090enum ftdi_chip_type type = TYPE_232H;
1091endef
1092export FTDI_232H_TEST
1093
Stefan Tauner56787082011-08-18 02:27:19 +00001094define UTSNAME_TEST
1095#include <sys/utsname.h>
1096struct utsname osinfo;
1097int main(int argc, char **argv)
1098{
1099 (void) argc;
1100 (void) argv;
1101 uname (&osinfo);
1102 return 0;
1103}
1104endef
1105export UTSNAME_TEST
1106
David Hendricksf9a30552015-05-23 20:30:30 -07001107define LINUX_MTD_TEST
1108#include <mtd/mtd-user.h>
1109
1110int main(int argc, char **argv)
1111{
1112 (void) argc;
1113 (void) argv;
1114 return 0;
1115}
1116endef
1117export LINUX_MTD_TEST
1118
Stefan Tauner8868db32012-03-13 00:18:19 +00001119define LINUX_SPI_TEST
1120#include <linux/types.h>
1121#include <linux/spi/spidev.h>
1122
1123int main(int argc, char **argv)
1124{
1125 (void) argc;
1126 (void) argv;
1127 return 0;
1128}
1129endef
1130export LINUX_SPI_TEST
1131
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001132define LINUX_I2C_TEST
1133#include <linux/i2c-dev.h>
1134#include <linux/i2c.h>
1135
1136int main(int argc, char **argv)
1137{
1138 (void) argc;
1139 (void) argv;
1140 return 0;
1141}
1142endef
1143export LINUX_I2C_TEST
1144
Nico Huber8624e8c2012-11-05 21:46:33 +01001145define CLOCK_GETTIME_TEST
1146#include <time.h>
1147
1148int main(int argc, char **argv)
1149{
1150 struct timespec res;
1151 clock_gettime(CLOCK_REALTIME, &res);
1152 return 0;
1153}
1154endef
1155export CLOCK_GETTIME_TEST
1156
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001157define NI845X_TEST
1158#include <ni845x.h>
1159
1160int main(int argc, char **argv)
1161{
1162 (void) argc;
1163 (void) argv;
1164 char I2C_Device[256];
1165 NiHandle Dev_Handle;
1166 uInt32 NumberFound = 0;
1167 ni845xFindDevice(I2C_Device, &Dev_Handle, &NumberFound);
1168 ni845xCloseFindDeviceHandle(Dev_Handle);
1169 return 0;
1170}
1171endef
1172export NI845X_TEST
1173
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001174features: compiler
1175 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001176ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001177 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001178 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001179 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001180 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1181 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
1182 printf "Checking for FT232H support in libftdi... " ; \
1183 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001184 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001185 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1186 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
1187 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
1188 ) || \
1189 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
1190 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001191endif
David Hendricksf9a30552015-05-23 20:30:30 -07001192ifeq ($(CONFIG_LINUX_MTD), yes)
1193 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1194 @echo "$$LINUX_MTD_TEST" > .featuretest.c
1195 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1196 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1197 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1198 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1199 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1200endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001201ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001202 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001203 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001204 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001205 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001206 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001207 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1208 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001209endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001210ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001211 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001212 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001213 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001214 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001215 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001216 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1217 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001218endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001219ifeq ($(CONFIG_NI845X_SPI), yes)
1220 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1221 @echo "$$NI845X_TEST" > .featuretest.c
1222 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1223
1224 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1225 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1226 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1227 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1228 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1229 echo "For the NI-845x 17.0 the library path is:"; \
1230 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1231 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1232 exit 1; }; } \
1233 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1234endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001235 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001236 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001237 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001238 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001239 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001240 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001241 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001242ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1243 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1244 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1245else
Nico Huber8624e8c2012-11-05 21:46:33 +01001246 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1247 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1248 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1249 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1250 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1251 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001252endif
Stefan Tauner56787082011-08-18 02:27:19 +00001253 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1254 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001255
Stefan Tauner4c723152016-01-14 22:47:55 +00001256$(PROGRAM).8.html: $(PROGRAM).8
1257 @groff -mandoc -Thtml $< >$@
1258
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001259$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001260 @# Add the man page change date and version to the man page
Stefan Taunerf0cbbb02017-10-01 00:49:05 +02001261 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001262
1263install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001264 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001265 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001266 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001267 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001268
Nico Huber454f6132012-12-10 13:34:10 +00001269libinstall: libflashrom.a libflashrom.h
1270 mkdir -p $(DESTDIR)$(PREFIX)/lib
1271 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1272 mkdir -p $(DESTDIR)$(PREFIX)/include
1273 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1274
Stefan Tauner76347082016-11-27 17:45:49 +01001275_export: $(PROGRAM).8
1276 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1277 @mkdir -p "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1278 @git archive HEAD | tar -x -C "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
Stefan Tauner2dc5d292017-10-04 02:18:33 +02001279# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1280 @echo "VERSION = $(VERSION)" > "$(EXPORTDIR)/flashrom-$(RELEASENAME)/versioninfo.inc"
1281 @echo "MAN_DATE = $(MAN_DATE)" >> "$(EXPORTDIR)/flashrom-$(RELEASENAME)/versioninfo.inc"
Stefan Taunere4136852017-10-01 15:57:25 +02001282# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1283# sed is required to filter out file names having the attribute set.
1284# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1285# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001286 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1287 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001288 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001289 xargs -0 sh -c 'for f; do \
1290 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
1291 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001292 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001293
Stefan Tauner76347082016-11-27 17:45:49 +01001294export: _export
1295 @echo "Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/"
1296
1297tarball: _export
David Hendrickse1a960e2017-10-19 14:54:44 -07001298 @tar -cj --format=ustar -f "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
Stefan Tauner60f7a222017-10-01 15:45:06 +02001299 $(TAROPTIONS) "flashrom-$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001300# Delete the exported directory again because it is most likely what's expected by the user.
1301 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
David Hendrickse1a960e2017-10-19 14:54:44 -07001302 @echo Created "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001303
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001304libpayload: clean
1305 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001306
Felix Singer9441c6e2022-10-21 12:47:11 +02001307gitconfig:
1308 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1309
1310.PHONY: all install clean distclean compiler hwlibs features _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001311
Stefan Tauner23e10b82016-01-23 16:16:49 +00001312# Disable implicit suffixes and built-in rules (for performance and profit)
1313.SUFFIXES:
1314
Stefan Reinauere2f01582010-06-07 11:08:07 +00001315-include $(OBJS:.o=.d)